'use strict';

const postcss = require('postcss-js');
const autoprefixer = require('autoprefixer');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e["default"] : e; }

const postcss__default = /*#__PURE__*/_interopDefaultLegacy(postcss);
const autoprefixer__default = /*#__PURE__*/_interopDefaultLegacy(autoprefixer);

const prefixer = postcss__default.sync([autoprefixer__default]);
function autoprefixerPreset() {
  return {
    name: "unocss-preset-autoprefixer",
    postprocess: (util) => {
      util.entries = genEntries(prefixer(Object.fromEntries(util.entries)));
    }
  };
}
const hyphenate = (str) => str.replace(/(?:^|\B)([A-Z])/g, "-$1").toLowerCase();
function genEntries(obj) {
  const res = [];
  Object.keys(obj).forEach((key) => {
    if (Array.isArray(obj[key])) {
      obj[key].forEach((v) => {
        res.push([hyphenate(key), v]);
      });
    } else if (typeof obj[key] === "string") {
      res.push([hyphenate(key), obj[key]]);
    }
  });
  return res;
}

module.exports = autoprefixerPreset;
