import postcss from 'postcss-js';
import autoprefixer from 'autoprefixer';

const prefixer = postcss.sync([autoprefixer]);
function autoprefixerPreset() {
  return {
    name: "unocss-preset-autoprefixer",
    postprocess: (util) => {
      util.entries = genEntries(prefixer(Object.fromEntries(util.entries)));
    }
  };
}
const hyphenate = (str) => str.replace(/(?:^|\B)([A-Z])/g, "-$1").toLowerCase();
function genEntries(obj) {
  const res = [];
  Object.keys(obj).forEach((key) => {
    if (Array.isArray(obj[key])) {
      obj[key].forEach((v) => {
        res.push([hyphenate(key), v]);
      });
    } else if (typeof obj[key] === "string") {
      res.push([hyphenate(key), obj[key]]);
    }
  });
  return res;
}

export { autoprefixerPreset as default };
